#include <stdlib.h>

#include <arch.h>
#include <device.h>

/* Externally used variables: */
byte *HW_OffscreenBuffer=0;
signed_32bit HW_ScreenSizeX;
signed_32bit HW_ScreenSizeY;
signed_32bit HW_ScreenMaxX;
signed_32bit HW_ScreenMaxY;
signed_32bit HW_ScreenCenterX;
signed_32bit HW_ScreenCenterY;
unsigned_32bit HW_BytesPerRow;

/* Internal variables: */

int HW_OpenScreen(void)
{
  HW_ScreenSizeX=320;
  HW_BytesPerRow=320;
  HW_ScreenSizeY=200;
  HW_ScreenMaxX=HW_ScreenSizeX-1;
  HW_ScreenMaxY=HW_ScreenSizeY-1;
  HW_ScreenCenterX=(HW_ScreenSizeX/2)<<4;
  HW_ScreenCenterY=(HW_ScreenSizeY/2)<<4;


  HW_OffscreenBuffer=malloc(64000);

  if (HW_OffscreenBuffer==0) {
    return 0;
  }

  /* do some hardware initalization */

  return 1;
}

void HW_DisplayScreen(void)
{
  /* copy offscreen buffer to screen */
}

void HW_SetPalette(byte *orgpal) 
{
  /* set palette */
}

void HW_ClearOffscreen(void)
{
  HW_MemSet(HW_OffscreenBuffer, 0, HW_BytesPerRow*HW_ScreenSizeY);
}

void HW_CloseScreen(void)
{
  /* close screen */

  if (HW_OffscreenBuffer) {
    free(HW_OffscreenBuffer);
  }
}


